Scrum - Defect #1289

Error in calendar
2017-01-31 20:17 - Lars Van Casteren

Status: New

Priority: Normal

Category: Calendar

Target version:

Source: Customer Blocked: No
Detected on version: Scrum v0.16.2 Alone:

Description

Hi, thanks for your highly appreciated plugins, they have proven to be a must-have for Redmine time & time again!
I'm trying to enable scrum on an existing environment (thats also running advanced roadmap).

| installed a working redmine 3.3.2/scrum, and then moved our production database (+plugins) to the new instance.
| did apply your diff's from advanced roadmap that didn't make it into the release to our prod environment.

This is what happens when opening calendar view:

ActiveRecord::StatementInvalid (Mysql2::Error: Unknown column 'issues.id' in 'IN/ALL/ANY subquery'
SELECT “sprints’ . id" AS tO_r0, “sprints’. name’ AS tO_rl, “sprints’ . description’ AS t0_r2, ’sp
rints’ . sprint_start_date’ AS t0_r3, 'sprints . sprint_end_date’ AS t0_r4, " sprints . user_id  AS
t0_r5, “sprints’ . project_id’ AS t0_r6, "sprints . created_on' AS tO_r7, " sprints’ . updated_on’ AS
t0_r8, “sprints’ . is_product_backlog® AS t0_r9, “sprints’ . status’ AS t0_rl0, " sprints’ . shared’
AS t0_rll, "projects . id’ AS tl_r0, "projects . name’ AS tl_rl, “projects . description’ AS tl_r2
, projects . homepage® AS tl_r3, “projects . is_public’ AS tl_r4, "projects . parent_id® AS tl_r5
, projects . created_on® AS tl_r6, “projects’ . updated_on® AS tl_r7, ‘projects . identifier’ AS t
1_r8, ‘projects’ . status® AS tl_r9, ‘projects’ . 1ft’ AS tl_rl10, “projects . rgt® AS tl_rll, “proje
cts’ . inherit_members® AS tl_rl2, “projects’ . default_version_id’ AS tl_rl3, ‘projects . product_b

acklog_id" AS tl_rl4 FROM  sprints’ INNER JOIN "projects’ ON "projects . id’ = “sprints . project_
id® WHERE ((((projects.lft >= 23 AND projects.rgt <= 26) OR issues.id IN (SELECT issue_id FROM iss
ues_projects WHERE project_id = 8)))) AND " sprints . is_product_backlog® = 0 AND ( sprints’ . sprin

t_start_date® BETWEEN '2016-12-26' AND '2017-02-05")):
plugins/scrum/lib/scrum/calendars_controller_patch.rb:35:in "“query_sprints'
plugins/scrum/lib/scrum/calendars_controller_patch.rb:24:in ~add_sprints'
plugins/advanced_roadmap/lib/advanced_roadmap/calendars_controller_patch.rb:12:in ‘add_milestone

SV
lib/redmine/sudo_mode.rb:63:in ' sudo_mode'

For the moment I'm working around it by commenting out in calendars_controller_patch.rb:

#query_sprints (sprints, Qquery, @calendar, true)

#query_sprints (sprints, Qquery, @calendar, false)

response.body += view.render (:partial => 'scrum_hooks/calendars/sprints',
:locals => {:sprints => sprints})

end
# private
# def query_sprints(sprints, query, calendar, start)
# date_field = start ? 'sprint_start_date' : 'sprint_end_date'
# query.sprints.where (date_field => calendar.startdt..calendar.enddt,
# is_product_backlog: false).each do |sprint|
# sprints << {:name => sprint.name,
# :url => url_for(:controller => :sprints,
# raction => :show,
# :id => sprint.id,
# :only_path => true),
# :day => sprint.send(date_field) .day,
# :week => sprint.send(date_field) .cweek,
# :start => start}
# end
# end
Some info:

Environment:
Redmine version 3.3.2.stable.16215
Ruby version 2.2.4-p230 (2015-12-16) [x86_64-1inux]
Rails version 4.2.7.1
Environment production
Database adapter Mysqgl2

SCM:
Subversion 1.7.14
Git 1.8.3.1
Filesystem
GitRemote 1.8.3.1

Redmine plugins:
advanced_roadmap
issue_charts

redmine_agile
redmine_banner
redmine_base_deface
redmine_checklists
redmine_ckeditor
redmine_git_remote
redmine_image_clipboard_paste
redmine_issue_completion
redmine_issue_templates
redmine_issues_tree
redmine_login_audit
redmine_maintenance_mode
redmine_multiprojects_issue
redmine_my_page
redmine_shady
release_logs
usability

History

#1 - 2017-02-01 10:41 - Emilio Gonzalez Montaina

- Category set to Calendar

| cannot reproduce this bug (my calendar view is working), please provide more details about the steps to achieve it...

#2 - 2023-02-12 17:09 - Javier Pastor

Hi, | have the same error.

| have reviewed the results of the query that gives the error and the problem seems to be in the SELECT that is in the WHERE.
If you remove the select the error is no longer thrown in the SQL query.

SELECT “sprints® . id’ AS t0_r0, “sprints’ . name’ AS tO_rl, "sprints . description’ AS tO_r2, ‘sprints’.
sprint_start_date’ AS tO0_r3, ‘sprints’ . sprint_end _date’ AS t0_r4, “sprints .’ user_id® AS t0_r5, " sprints’.
‘project_id® AS t0_r6, "~ sprints’. created_on® AS t0_r7, " sprints’ . updated_on® AS t0_r8, “sprints’.
“is_product_backlog® AS t0_r9, “sprints’ . status® AS t0_rl0, “sprints . shared’ AS tO_rll, ‘projects . id’ AS
tl_r0, “projects’ . name’ AS tl_rl, ‘projects’ . description’ AS tl_r2, ‘projects’ . homepage  AS tl_r3,
‘projects . is_public® AS tl_r4, ‘projects . parent_id’ AS tl_r5, ‘projects . created_on’ AS tl_r6, ‘projects’
."updated_on® AS tl_r7, “projects . identifier’ AS tl_r8, "projects . status’ AS tl_r9, ‘projects . 1lft’ AS
tl_rl0, “projects . rgt’ AS tl_rll, “projects . inherit_members® AS tl_rl2, ‘projects . product_backlog_id"  AS
tl_rl3, “projects . default_version_id" AS tl_rl4, "projects . default_assigned_to_id’ AS tl_rl5, “projects .

“activity_report_settings® AS tl_rl6 FROM " sprints® INNER JOIN "projects’ ON “projects . id’ = “sprints’.
‘project_id® WHERE ((((projects.id = 55) OR issues.id IN (SELECT issue_id FROM issues_projects WHERE
project_id = 55)))) AND " sprints’ . sprint_start_date’ BETIWEEN '2023-01-30' AND '2023-03-05"' AND " sprints’.
“is_product_backlog® = FALSE
If we review the next piece of the query we see that issues.id is being referenced and that table is not being referenced anywhere.
It may be a typo error that instead of issues.if it is projects.id?

Error:

WHERE ((((projects.id = 55) OR issues.id IN (SELECT issue_id FROM issues_projects WHERE project_id = 55))))
AND

Fix???

WHERE ((((projects.id = 55) OR projects.id IN (SELECT issue_id FROM issues_projects WHERE project_id = 55))))
AND

Error:

Processing by CalendarsController#show as HTML
Rendering calendars/show.html.erb within layouts/base
Rendered queries/_filters.html.erb (8.4ms)
Rendered common/_calendar.html.erb (7.3ms)
Rendered plugins/redmine_issue_templates/app/views/issue_templates/_issue_template_link.html.erb (0.6ms)
Rendered issues/_sidebar.html.erb (3.8ms)
Rendered calendars/show.html.erb within layouts/base (21.6ms)
Rendered plugins/redmine_code_review/app/views/code_review/_html_header.html.erb (1.3ms)
Rendering inline template
Rendered inline template (0.3ms)
Rendered plugins/redmine_wysiwyg_editor/app/views/redmine_wysiwyg_editor/_redmine_wysiwyg_editor_partial.htm
l.erb (0.1lms)
Rendered plugins/scrum/app/views/scrum_hooks/_head.html.erb (0.2ms)
Rendered plugins/scrum/app/views/scrum_hooks/_scrum_tips.html.erb (0.3ms)
Rendered plugins/redmine_code_review/app/views/code_review/_body_bottom.html.erb (0.1lms)
Rendered plugins/redmine_drawio/app/views/redmine_drawio/_macro_dialog.html.erb (0.3ms)
Rendered plugins/redmine_sticky_messages/app/views/messages/_after_top_menu.html.erb (3.1ms)
Completed 500 Internal Server Error in 208ms (Views: 31.9ms | ActiveRecord: 160.3ms)

ActiveRecord: :StatementInvalid (Mysqgl2::Error: Unknown column 'issues.id' in 'IN/ALL/ANY subquery': SELECT °sp
rints’ . id" AS t0_r0, “sprints’ . name ™ AS tO_rl, “sprints’ . description’ AS tO_r2, “sprints . sprint_start_dat
e’ AS tO0_r3, “sprints’. sprint_end_date® AS t0_r4, "sprints’ . user_id’ AS t0_r5, “sprints’ . project_id® AS tO0_
r6, “sprints’. created_on® AS t0O_r7, " sprints’ . updated_on® AS t0_r8, “sprints’ . is_product_backlog® AS t0_r9,
“sprints’ . status® AS t0_rl0, “sprints’ . shared’ AS t0O_rll, "projects . id" AS tl_r0, “projects . name  AS tl
_rl, “projects’ . description’ AS tl_r2, ‘projects . homepage’ AS tl_r3, “projects . is_public® AS tl_r4, ‘proj
ects’ . parent_id" AS tl_r5, ‘projects’ .’ created_on' AS tl_r6, “projects . updated_on’ AS tl_r7, ‘projects . id
entifier’ AS tl_r8, “projects . status’ AS tl_r9, "projects . 1lft® AS tl_rl0, "projects . rgt® AS tl_rll, ‘“pro
jects’ . inherit_members’ AS tl_rl2, ‘projects’ . product_backlog_id' AS tl_rl3, ‘projects’ . default_version_id"
AS tl_rl4, “projects’ . default_assigned_to_id" AS tl_rl5, “projects . activity_report_settings® AS tl_rl6 FRO
M “sprints® INNER JOIN "projects’ ON “projects’ . id’ = “sprints’ . project_id’ WHERE ((((projects.id = 55) OR i
ssues.id IN (SELECT issue_id FROM issues_projects WHERE project_id = 55)))) AND " sprints . sprint_start_date’
BETWEEN '2023-01-30' AND '2023-03-05' AND "sprints’ . is_product_backlog’ = FALSE):

plugins/scrum/lib/scrum/calendars_controller_patch.rb:35:in “query_sprints'
plugins/scrum/lib/scrum/calendars_controller_patch.rb:24:in ‘add_sprints'
lib/redmine/sudo_mode.rb:61:in "~ sudo_mode'

Info:
Environment:
Redmine version 4.2.9.stable.22090
Ruby version 2.7.6-p219 (2022-04-12) [x86_64-1linux]
Rails version 5.2.8.1
Environment production
Database adapter Mysqgl2
Mailer queue ActiveJdob: :QueueAdapters: :AsyncAdapter
Mailer delivery smtp
SCM:
Subversion 1.14.2
Mercurial 6.1.4
Cvs 1.12.12
Git 2.35.1
Filesystem
GitMirror 2.35.1
Redmine plugins:
custom_tables 1.0.6
redmine_base_deface
redmine_base_stimulusjs
redmine_code_review
redmine_dashboard
redmine_documents_short
redmine_drawio
redmine_git_mirror
redmine_issue_badge
redmine_issue_dynamic_edit
redmine_issue_evm
redmine_issue_favicon
redmine_issue_templates
redmine_issue_todo_lists
redmine_ldap_sync
redmine_logs
redmine_multiprojects_issue
redmine_my_page
redmine_pam_auth
redmine_status_history
redmine_sticky_messages
redmine_theme_changer
redmine_wysiwyg_editor
scrum
